from importlib.metadata import version

__version__ = version("jymkit")
from jymkit import _make

from ._environment import Environment as Environment, TimeStep as TimeStep
from ._spaces import (
    Box as Box,
    Discrete as Discrete,
    MultiDiscrete as MultiDiscrete,
    Space as Space,
)
from ._types import AgentObservation as AgentObservation
from ._wrappers import (
    LogWrapper as LogWrapper,
    NormalizeVecObsWrapper as NormalizeVecObsWrapper,
    NormalizeVecRewardWrapper as NormalizeVecRewardWrapper,
    VecEnvWrapper as VecEnvWrapper,
    is_wrapped as is_wrapped,
    remove_wrapper as remove_wrapper,
)

make = _make.make
